# coding=UTF8
# Copyright © 2010 Rob Leachman
# Please see the file COPYING in this distribution for license information

## (Including for posterity, I started learning Python and did this project
## to get some experience. I wrote this test on November 2 so came a long way
## in a month!)
##
##Object of the game is to collect 10 things
##
##A generator produces a thing after 10 cycles
##A harvester will find a thing and put it to the collection; 5 cycles to get to the thing and 5 to return to the collection
##Can sell a thing and to get coins, to buy more generators and harvesters
##
##Start with 300 coins
##
##option 0 (just hit enter):
##	run another cycle
##
##option 1:
##	build a generator for 200 coins
##
##option 2:
##	build a harvester for 100 coins
##
##option 3: 
##	sell a thing from the collection and get 100 coins
##
##
##Each cycle:
##
##A.	Increment cycle count
##
##B.	Process input options:
##if option=1
##	check coin count, if greater than 199
##		deduct 200 coins
##		add 1 generator
##			thing-ready = false
##			targeted = false
##			processor count=0			
##if option=2
##	check coin count, if greater than 99
##		deduct 100 coins
##		add 1 harvester
##if option=3
##	check collection count, if greater than 0
##		deduct 1 thing from collection
##		add 100 coins to coin count
##
##C.	Process cycle:
##For each generator
##	If not thing-ready:
##		Increment processor count
##		If processor count == 10
##			processor count = 0
##			set thing-ready = true
##
##For each harvester:
##	If state = idle
##		For each generator
##			If thing-ready = true and targeted=false
##				State = harvesting
##				Target = generator
##				Target targeted = true
##				Progress = 0
##	If state = harvesting
##		Increment progress
##		If progress > 4
##			state = carrying
##			progress = 0
##			target thing-ready = false
##			target targeted = false
##	If state = carrying
##		increment return
##		if return > 4
##			state = idle
##			return = 0
##			increment collection count	
##
##D. Check win condition
##
##E. Display status

won=0
coins=300
cycle=0
collection=0
generators = []
harvesters = []


while won == 0:
    cycle += 1
    
    option = raw_input('1=buy generator, 2=buy harvester, 3=sell, 0=go:')

    if (option == '1'):
##	check coin count, if greater than 199
##		deduct 200 coins
##		add 1 generator
##			thing-ready = false
##			targeted = false
##			processor count=0			
       if (coins > 199):
            print "You bought a generator!"
            coins = coins - 200
            generator = [False, False, 0]
            generators.append(generator)
       else:
            print "Cannot afford a generator!"

##if option=2
##	check coin count, if greater than 99
##		deduct 100 coins
##		add 1 harvester
##          state = idle
##          target = -1 (nobody)
##          progress = 0  
    if (option == '2'):
        if (coins > 99):
            print "You bought a harvester!"
            coins = coins - 100
            harvester = ['Idle', -1, 0]
            harvesters.append(harvester)
        else:
            print "Cannot afford a harvester!"

##if option=3
##	check collection count, if greater than 0
##		deduct 1 thing from collection
##		add 100 coins to coin count
    
    if (option == '3'):
        if (collection > 0):
            print "You're selling a thing!"
            collection -= 1
            coins += 100
        else:
            print "No thing to sell!"
    

##For each generator
##	If not thing-ready:
##		Increment processor count
##		If processor count == 10
##			processor count = 0
##			set thing-ready = true
    for generator in generators:
        if (generator[0] == False): # not already ready
            generator[2] += 1
            if (generator[2] == 10):
                generator[0] = True
                generator[2] = 0

##For each harvester:
##	If state = idle
##		For each generator
##			If thing-ready = true and targeted=false
##				State = harvesting
##				Target = generator
##				Target targeted = true
##				Progress = 0
##	If state = harvesting
##		Increment progress
##		If progress > 4
##			state = carrying
##			progress = 0
##			target thing-ready = false
##			target targeted = false
##	If state = carrying
##		increment return
##		if return > 4
##			state = idle
##			return = 0
##			increment collection count	
    for harvester in harvesters:
            state = harvester[0]
            if (state == "Idle"):
                for generator in generators:
                    if (generator[0] == True) and (generator[1] == False):

                        state = "Harvesting"
                        harvester[0] = state
                        harvester[1] = generators.index(generator)
                        generator[1] = True
                        harvester[2] = 0
            if (state == "Harvesting"):
                harvester[2] += 1
                if (harvester[2] > 4):
                    state = "Carrying"
                    harvester[0] = state
                    harvester[2] = 0
                    generator = generators[harvester[1]]
                    generator[0] = False  
                    generator[1] = False
            if (state == "Carrying"):
                harvester[2] += 1
                if (harvester[2] > 4):
                    state = "Idle"
                    harvester[0] = state
                    harvester[2] = 0
                    collection += 1



##D. Check win condition
    print "Cycle", cycle
    print "     Coins =", coins
    print "     Collection =", collection

    if (collection == 10):
        print "You win at cycle #", cycle
        won = 1


##E. Display status
   
    for generator in generators:
        print "Generator is ready:", generator[0]
        print "Generator is targeted:", generator[1]
        print "Generator process count:", generator[2]
    
    for harvester in harvesters:
        print "Harvester state:", harvester[0]
        print "Harvester target:", harvester[1]
        print "Harvester progress:", harvester[2]
    
    print
    
