# coding=UTF8
# Copyright © 2010 Rob Leachman
# Please see the file COPYING in this distribution for license information
# Added a shortcut to /applications/SPE.app/Contents/Resources/_spe/shortcuts
# Now it ends with:
#   'Run in terminal without arguments  exit'    : 'Ctrl+X',
# SWEET!

TIMER = 20 #20 is good for prod
SPEED = 5
YOURSPEED = 2

import pygame, sys
from pygame.color import THECOLORS
pygame.init()

from pygame.locals import *

#pygame.mouse.set_visible(0)  # interesting? hides mouse in window
#print pygame.key.name(120)   # prints the name of a key code
#screen.fill([255,255,255])   # white background


class You:
    def __init__(self):
        self.goalX = 3
        self.goalY = 1
        self.locationX = getMapX(self.goalX,self.goalY)
        self.locationY = getMapY(self.goalX,self.goalY)
        
        pygame.draw.rect(screen, THECOLORS["orange1"], [self.locationX,self.locationY,40,40], 0)
        
    def aimLeft(self):
        if (self.goalX > 0):
            self.goalX = self.goalX - 1
        
    def aimRight(self):
        testX = getMapX(self.goalX + 1, self.goalY)
        if testX <> -1:
            self.goalX = self.goalX + 1
            
    def aimUp(self):
        if (self.goalY == 0):
            print "edge"
            return
        self.goalY = self.goalY - 1
    
    def aimDown(self):
        testY = getMapY(self.goalX, self.goalY + 1)
        if testY <> -1:
            self.goalY = self.goalY + 1
        
    def move(self):
        goalX = getMapX(self.goalX,self.goalY)
        goalY = getMapY(self.goalX,self.goalY)
        
        newX = self.locationX
        newY = self.locationY
        
        if self.locationX < goalX:
            newX = newX + YOURSPEED
            if newX > goalX:
                newX = goalX
        if self.locationX > goalX:
            newX = newX - YOURSPEED
            if newX < goalX:
                newX = goalX
        if self.locationY < goalY:
            newY = newY + YOURSPEED
            if newY > goalY:
                newY = goalY
        if self.locationY > goalY:
            newY = newY - YOURSPEED
            if newY < goalY:
                newY = goalY

            
        #print ("GoalX",goalX,"GoalY",goalY,"CurX",self.locationX,"CurY",self.locationY)
        
        pygame.draw.rect(screen, THECOLORS["black"], [self.locationX,self.locationY,40,40], 0)
        self.locationX = newX
        self.locationY = newY
        pygame.draw.rect(screen, THECOLORS["orange1"], [self.locationX,self.locationY,40,40], 0)
            
            
class Harvester:
    def __init__(self, count):
        self.state = "Idle"
        self.target = -1
        self.progress = 0
        self.fleetPosition = count

        screenX = getLocationX(4)
        screenY = getLocationY(4)
    
        pygame.draw.rect(screen, [255,0,0], 
            [(screenX + 5) + (self.fleetPosition+1) * 7,(screenY + 70),5,5],0)
            
    def spawn(self):
        # home location
        self.locationX = 165
        self.locationY = 230
        
        screenX = getLocationX(4)
        screenY = getLocationY(4)
    
        pygame.draw.rect(screen, [255,255,255], 
            [(screenX + 5) + (self.fleetPosition+1) * 7,(screenY + 70),5,5],0)
        #pygame.draw.rect(screen, [200,0,0], [35,100,40,40], 0) #harvester
        pygame.draw.rect(screen, [200,0,0], [self.locationX,self.locationY,40,40], 0)

    def move(self, goalX, goalY, pathDirection):
        # erase where we're at now
        pygame.draw.rect(screen, [0,0,0], [self.locationX,self.locationY,40,40], 0)
        
        # then move, like add 1 to y
        if self.locationY < goalY:
            self.locationY = self.locationY + SPEED
            if self.locationY > goalY:
                self.locationY = goalY
        if self.locationY > goalY:
            self.locationY = self.locationY - SPEED
            if self.locationY < goalY:
                self.locationY = goalY
        if self.locationX < goalX:
            self.locationX = self.locationX + SPEED
            if self.locationX > goalX:
                self.locationX = goalX
        if self.locationX > goalX:
            self.locationX = self.locationX - SPEED
            if self.locationX < goalX:
                self.locationX = goalX
        
        # draw new
        pygame.draw.rect(screen, [200,0,0], [self.locationX,self.locationY,40,40], 0)
        if self.state == "Carrying":
           self.harvest()
        
        if self.locationX == goalX and self.locationY == goalY:
            if pathDirection == 1:
                self.progress = self.progress + 1
            else:
                self.progress = self.progress - 1
        return self.progress
    
    def harvest(self):
        pygame.draw.rect(screen, [0,255,0], 
               [(self.locationX + 5), (self.locationY + 5),30,30],0)
            
    def home(self):
        # erase from playfield
        pygame.draw.rect(screen, [0,0,0], [self.locationX,self.locationY,40,40], 0)
        # add back to home list
        screenX = getLocationX(4)
        screenY = getLocationY(4)
    
        pygame.draw.rect(screen, [255,0,0], 
            [(screenX + 5) + (self.fleetPosition+1) * 7,(screenY + 70),5,5],0)

        
    
class Generator:

    def __init__(self, location):
        
        self.location = location # hardcoded for now
        self.isReady = False
        self.isTargeted = False
        self.processCount = 0
        self.cycleCount = 0
        
        screenX = getLocationX(location)
        screenY = getLocationY(location)
#        pygame.draw.rect(screen, [0,0,200], [15,15,80,80],0) # generator
#        pygame.draw.rect(screen, [100,100,0], [35,20,40,40],0) # result box
        
        pygame.draw.rect(screen, [0,0,200], [screenX+5,screenY+5,80,80],0) # generator
        pygame.draw.rect(screen, [100,100,0], [screenX+25,screenY+10,40,40],0) # result box
        
    def __str__(self):
        msg = "GENERATOR DEBUGGER:" + "\n"
        msg += " Location: " + str(self.location) + "\n"
        msg += " Ready: " + str(self.isReady) + "\n"
        msg += " Targeted: " + str(self.isTargeted) + "\n"
        msg += " Process count: "  + str(self.processCount) + "\n"
        return msg
                
    def produce(self):

        screenX = getLocationX(self.location)
        screenY = getLocationY(self.location)
                
        if (self.processCount == 10):
            self.isReady = True

            pygame.draw.rect(screen, [0,255,0], 
               [(screenX + 30), (screenY + 15),30,30],0)
        if (self.isReady == False):
            self.cycleCount = self.cycleCount + 1
            if self.cycleCount > TIMER:
                self.cycleCount = 0
                self.processCount = self.processCount + 1
                pygame.draw.rect(screen, [255,255,0], 
                    [(screenX + 4) + self.processCount * 7,(screenY + 70),5,5],0)
                    
    def harvest(self):
        self.isReady = False
        self.isTargeted = False
        self.processCount = 0
        self.cycleCount = 0
        screenX = getLocationX( self.location )
        screenY = getLocationY( self.location )
        pygame.draw.rect(screen, [100,100,0], [screenX+25,screenY+10,40,40],0) # result box
        pygame.draw.rect(screen, [0,0,200], 
                    [ screenX + 5, screenY + 70,80,5],0)
                    


def getLocationX(location):
    screenX = 0
    if (location == 0 or location == 3 or location == 6):
        screenX = 10 
    if (location == 1 or location == 4 or location == 7):
        screenX = 140
    if (location == 2 or location == 5 or location == 8):
        screenX = 270
    return screenX

def getLocationY(location):
    screenY = 0
    
    if (location == 0 or location == 1 or location == 2):
        screenY = 10 
    if (location == 3 or location == 4 or location == 5):
        screenY = 140
    if (location == 6 or location == 7 or location == 8):
        screenY = 270
    return screenY
         
def displayNewHarvester():
    screenX = getLocationX(4)
    screenY = getLocationY(4)
    
    harvCount = len(harvesters)
    pygame.draw.rect(screen, [255,0,0], 
        [(screenX + 5) + harvCount * 7,(screenY + 70),5,5],0)
        
def getMapX(mapLocX, mapLocY):
    if mapLocX > len(map[mapLocY]) - 1:
        return -1
    return map[mapLocY][mapLocX][0]

def getMapY(mapLocX, mapLocY):
    if mapLocY > len(map) - 1:
        return -1
    return map[mapLocY][mapLocX][1]


## INIT
generators = []
harvesters = []

genKeys = [ pygame.K_KP7, pygame.K_KP8, pygame.K_KP9, 
            pygame.K_KP4, pygame.K_KP5, pygame.K_KP6,
            pygame.K_KP1, pygame.K_KP2, pygame.K_KP3]
            
path = [ [[165,230], [100, 230], [100, 100], [35, 100],  [-1,-1]],
         [[165,230], [100, 230], [100, 100], [165, 100], [-1,-1]],
         [[165,230], [230, 230], [230, 100], [295, 100], [-1,-1]],
         
         [[165,230], [100, 230], [35,  230], [-1,-1]],
         [[165,230]],
         [[165,230], [230, 230], [295, 230], [-1,-1]],
         
         [[165,230], [100, 230], [100, 360], [35, 360], [-1,-1]],
         [[165,230], [100, 230], [100, 360], [165,360], [-1,-1]],
         [[165,230], [230, 230], [230, 360], [295,360], [-1,-1]]
        ]
        
map =   [ [[0,100], [35,100], [100,100], [165,100], [230,100], [295,100], [350,100]],
          [[0,230], [35,230], [100,230], [165,230], [230,230], [295,230], [350,230]],
          [[0,360], [35,360], [100,360], [165,360], [230,360], [295,360], [350,360]],
        ]
        
myClock = pygame.time.Clock()

screen = pygame.display.set_mode([800,600])

##pygame.draw.rect(screen, [100,100,100], [10,10,90,90],0)
##pygame.draw.rect(screen, [100,100,100], [140,10,90,90],0)
##pygame.draw.rect(screen, [100,100,100], [280,10,90,90],0)
###pygame.draw.rect(screen, [200,0,0], [35,100,40,40], 0) #harvester
##pygame.draw.rect(screen, [100,100,100], [10,140,90,90],0)
##pygame.draw.rect(screen, [255,255,255], [140,140,90,90],0)
##pygame.draw.rect(screen, [100,100,100], [280,140,90,90],0)
##pygame.draw.rect(screen, [100,100,100], [10,280,90,90],0)
##pygame.draw.rect(screen, [100,100,100], [140,280,90,90],0)
##pygame.draw.rect(screen, [100,100,100], [280,280,90,90],0)


# Draw the pads
for loc in range (0,9):
    if loc == 4:
        pygame.draw.rect(screen, [255,255,255], [getLocationX(loc),getLocationY(loc),90,90],0)
    else:
        pygame.draw.rect(screen, [100,100,100], [getLocationX(loc),getLocationY(loc),90,90],0)
        
you = You()

while True:

    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            sys.exit()
        #print pygame.key.get_mods()  # show modifier keys
        #if (event.type == KEYUP) or (event.type == KEYDOWN): # show key
        #    print event

        if event.type == pygame.KEYDOWN:          # check for key presses
            if event.key == pygame.K_LEFT:        # left arrow turns left    
                you.aimLeft()
            if event.key == pygame.K_RIGHT:
                you.aimRight()
            if event.key == pygame.K_UP:
                you.aimUp()
            if event.key == pygame.K_DOWN:
                you.aimDown()
                
            if event.key in genKeys:
                genLocation = genKeys.index(event.key)
                
                if (genLocation == 4): # the base, add a harvester
                    harvCount = len(harvesters)
                    if (harvCount < 10):
                        print "You bought a harvester!"
                        newHarv = Harvester(len(harvesters))
                        harvesters.append(newHarv)
                        harvCount = len(harvesters)
                        print "Now have", harvCount, "harvesters"
                        #displayNewHarvester()
                    else:
                        print "Max 10 harvesters!"
                else: # a producing location, add a generator
                    foundGen = False
                    for generator in generators:
                        if generator.location == genLocation:
                            foundGen = True
                    if (foundGen == False):
                        print "You bought a generator!"
                        newGen = Generator(genLocation)
                        generators.append(newGen)
                
##            if event.key == pygame.K_p:
##                print "X!"
##                gen = Generator(0)                
##                generators.append(gen)
          #  if event.key == pygame.K_z:

            if event.key == pygame.K_p:
                for generator in generators:
                    print generator
        if (event.type == pygame.KEYDOWN):
            if (pygame.key.get_mods() == 1024): # command key
                if (event.key == 113):   # q
                    sys.exit()
             
    you.move()
    for generator in generators:
        generator.produce()
        
    for harvester in harvesters:
        state = harvester.state
        if state == "Idle":
            for generator in generators:
                # need to check idle here again because two generators could be ready at the same time...
                if state == "Idle" and generator.isReady == True and generator.isTargeted == False:
                    print "Found target to harvest"
                    state = "Harvesting"
                    harvester.state = state
                    harvester.target = generator.location
                    generator.isTargeted = True
                    harvester.progress = 0
                    harvester.spawn()
        if state == "Harvesting":
            
            goalX = path[harvester.target][harvester.progress][0]
            goalY = path[harvester.target][harvester.progress][1]
            
            if goalX <> -1:
                newProgress = harvester.move(goalX, goalY, 1)
            else:
                print "GOAL MET"
                state = "Carrying"
                harvester.state = state
                harvester.harvest()
                harvester.progress = harvester.progress - 1;
                for generator in generators:
                    if harvester.target == generator.location:
                        generator.harvest()
        if state == "Carrying":
            goalX = path[harvester.target][harvester.progress][0]
            goalY = path[harvester.target][harvester.progress][1]
            newProgress = harvester.move(goalX, goalY, -1) 
            if newProgress == -1:
                state = "Idle"
                harvester.state = state
                print "Home!"
                harvester.home()
                
    
                
    myClock.tick(40)
    fps = myClock.get_fps()
    pygame.display.flip()
                        
##            if (state == "Harvesting"):
##                harvester[2] += 1
##                if (harvester[2] > 4):
##                    state = "Carrying"
##                    harvester[0] = state
##                    harvester[2] = 0
##                    generator = generators[harvester[1]]
##                    generator[0] = False  
##                    generator[1] = False
##            if (state == "Carrying"):
##                harvester[2] += 1
##                if (harvester[2] > 4):
##                    state = "Idle"
##                    harvester[0] = state
##                    harvester[2] = 0
##                    collection += 1