# coding=UTF8
# Copyright © 2010 Rob Leachman
# Please see the file COPYING in this distribution for license information
## #! /usr/bin/env python

# Added a shortcut to /applications/SPE.app/Contents/Resources/_spe/shortcuts
# Now it ends with:
#   'Run in terminal without arguments  exit'    : 'Ctrl+X',
# Fast interative development, SWEET!

# Produce stuff with generators
# Can buy generators for cash
# Can sell stuff to get cash at market

# Need gas to produce stuff
# Can convert stuff to gas for coin

# Need stuff to power shield
# Need progressively better shields

# Need stuff to power laser
# Laser reduces need for shields

# With enough shields and lasers the attack ends - WIN

# Robots will harvest stuff
# Robots can be upgraded to refuel generators

# Start with a bunch of stuff
# Shields being depleted so restock with stuff
# Eventually realize you need to sell some stuff to get cash
# Buy a generator with some cash
# Now generator is producing stuff
# Keep restocking shields with stuff
# Attack increases so need more shields, stuff
# Have to sell stuff to get cash to buy generators
#
#
# Laser sound from http://www.freesound.org/samplesViewSingle.php?id=18387
# Music from http://www.jmickle.co.uk/
#
# -- Instruction mode
# -- No dead-ends
# -- Paint the instruction screen on pause
# -- Make the docking under the places more obvious
# -- Take out the money altogether


#pygame.mouse.set_visible(0)  # interesting? hides mouse in window


import pygame, sys, random
import os.path
from pygame.mixer import *
from pygame.color import THECOLORS
from pygame.locals import *

import pyconsole
from test_syntax import *
from test_functions import *

import enviro # my global game environment
import Noise # the noise module, all the music and effects stuff go here

from YourStuff import *
from AttackerStuff import *
from Fighter import Fighter
from FloatingSprite import FloatingSprite
from Harvester import Harvester
from MotherShip import MotherShip
from GasFactory import GasFactory
from Laser import Laser
from Shields import Shields
from Bomb import Bomb

import Title
import Menu

fullscreen = 1

def main(continuing, firstRun):
    # Init the screen and sound and everything... 
    pygame.init()
    Noise.initMixer()
    myClock = pygame.time.Clock()
    enviro.screen = pygame.display.set_mode([800,600])

    # Full-screen mojo from Arcade Tonk Tanks!
    if fullscreen == 1:
        screenrect = Rect(0, 0, 800, 600) 
        bestdepth = pygame.display.mode_ok(screenrect.size, pygame.FULLSCREEN, 32)
        enviro.screen = pygame.display.set_mode(screenrect.size, pygame.FULLSCREEN, bestdepth)
    #
    #enviro.screen.fill([255,255,255])   # white background... but we like black
    
    console = pyconsole.Console(
        enviro.screen, #The surface you want the console to draw on
        (401,0,328,449), #A rectangle defining the size and position of the console
        functions={"f":f,"prime":seive, "type":type, "line":line, "polygon":polygon, "circle":circle}, # Functions for the console
        key_calls={"d":sys.exit}, # Defines what function Control+char will call, in this case ctrl+d calls sys.exit()
        syntax={re_add:console_add, re_function:console_func}
        )
        
    pygame.display.set_caption('Produce, Defend, Win!')
    
    if firstRun:
        Title.run("myTitle.png", False)
        Title.run("instructions.png", True)
    
    if not continuing:
        
        enviro.credits = 0
        enviro.shieldUpgrades = 1
        enviro.laserUpgrades = 1
        enviro.gasFactoryIsBuilt = False
        enviro.botFactoryIsBuilt = False
        enviro.BOMB_POWER = 500
        
    if enviro.test == 1:
        enviro.gasFactoryIsBuilt = True
        enviro.botFactoryIsBuilt = True
##        enviro.credits = 20000        

    # Draw the pads, the base, get me a you, create some gas, all that stuff...
    enviro.start()

    if enviro.gasFactoryIsBuilt:
        enviro.gasFactory.build()
    if enviro.botFactoryIsBuilt:
        enviro.factory.build()

    instruction = "Arrow keys or WASD to move"
    font = pygame.font.Font(None, 20)
    instruction_text = font.render(instruction, 1, (255,255,255))
    instruction_pos = [10, 500]
    enviro.screen.blit(instruction_text, instruction_pos)
    instruction_text = font.render("Your goal is to make $50000", 1, (255,255,255))
    enviro.screen.blit(instruction_text, [10,520])
    
    enviro.writeCredits(enviro.credits)

    motherBecameActive = False

    fightersActive = 1
    frustration = 0

    shieldPower = enviro.START_SHIELD_POWER

    # The first one's free...
    newGen = Generator(5,enviro.gasGauges)
    newGen.refill(enviro.gasGauges)
    enviro.generators.append(newGen)

    bombList = pygame.sprite.Group()

    dramaBackground = pygame.image.load("dramaBackground.png")

    # Ready to play, bring up the music!
    Noise.playMusic('Concrete Water.ogg')
    pygame.mixer.music.set_volume(enviro.musicLevel[enviro.musicVolume])

    shooter = False
    paused = False

    shooting = False
    
    theKillerBomb = None

    alive = 1
    while alive == 1:
        
        releasedButton = False

        if not paused:
           enviro.screen.blit(dramaBackground, [400,0,330,449])

        console.process_input()
        for event in pygame.event.get():
            if event.type == pygame.KEYDOWN:          # check for key presses
                if event.key == K_w and pygame.key.get_mods() & KMOD_CTRL:
                    print "Console active!"
                    console.set_active()
                elif event.key == K_q and pygame.key.get_mods() & KMOD_CTRL: 
                    # Just a little hack so you can play with both pyconsole and python
                    # Hit ctrl w to hide pyconsole, then ctrl q to switch modes, then ctrl w again to show the console
                    # I don't expect anyone to actually use both modes in one app, if you really need to, you can be more creative than this.
                    console.setvar("python_mode", not console.getvar("python_mode"))
                    console.set_interpreter()   
                    
            if event.type == pygame.QUIT:
                sys.exit()
            elif event.type == pygame.MOUSEMOTION:
                newCursor = event.pos
                if (newCursor[0] > 400 and newCursor[0] < 730 and newCursor[1]<430):
                    pygame.mouse.set_cursor(*enviro.LASER_POINTER)
                    shooter = True
                else:
                    pygame.mouse.set_cursor(*pygame.cursors.arrow)
                    shooter = False
                    shooting = False
            elif event.type == pygame.MOUSEBUTTONDOWN:
                if shooter and not paused:
                    shooting = True
                    #print "shoot!"
##                else:
##                    print "no shot, either not in fight window or we are paused"
            elif event.type == pygame.MOUSEBUTTONUP:
                releasedButton = True
                
                #cursor.update(event.pos)

            #print pygame.key.get_mods()  # show modifier keys
            #if (event.type == KEYUP) or (event.type == KEYDOWN): # show key
            #    print "DEBUG KEY:", event

            if event.type == pygame.KEYDOWN:
                if (pygame.key.get_mods() == 1024): # command key
                    if (event.key == 113):   # q
                        sys.exit()

             
                if event.key == pygame.K_h and pygame.key.get_mods() & KMOD_CTRL:
                    print "HARVESTER DEBUG"
                    for harvester in enviro.harvesters:
                        print harvester
                
                if event.key == pygame.K_ESCAPE or event.key == pygame.K_p:
                    if paused:
                        enviro.writePaused(False)
                        paused = False
                    else:
                        enviro.writePaused(True)
                        paused = True
                        
                if event.key == pygame.K_m: # hit m for music mute
                    enviro.musicVolume += 1
                    if enviro.musicVolume > len(enviro.musicLevel) - 1:
                        enviro.musicVolume = 0
                    pygame.mixer.music.set_volume(enviro.musicLevel[enviro.musicVolume])
                if event.key == pygame.K_x: # hit s for effects mute
                    enviro.effectsVolume += 1
                    if enviro.effectsVolume > len(enviro.soundEffectsLevel) - 1:
                        enviro.effectsVolume = 0
                    for effect in enviro.soundEffect:
                        effect.set_volume(enviro.soundEffectsLevel[enviro.effectsVolume])
                        
                if event.key == pygame.K_t:
                    print "REFUEL"
                    enviro.laser.stashStuff()
                if event.key == pygame.K_n:
                    print "NUKE"
                    alive = 0
                    
                
                if paused:
                    #print pygame.key.name(109)   # prints the name of a key code
                    break # no other commands will be processed until unpause
                if event.key == pygame.K_LEFT or event.key == pygame.K_a:        
                    enviro.you.aimLeft(enviro.pads)
                if event.key == pygame.K_RIGHT or event.key == pygame.K_d:
                    enviro.you.aimRight(enviro.pads)
                if event.key == pygame.K_UP or event.key == pygame.K_w:
                    enviro.you.aimUp(enviro.pads)
                if event.key == pygame.K_DOWN or event.key == pygame.K_s:
                    enviro.you.aimDown(enviro.pads)
                if event.key == pygame.K_SPACE:
                    action = enviro.you.interact(enviro.generators, enviro.shields, enviro.theBase, enviro.laser)
                    #print "key ACTION at ", action[0], "act=", action[1]
                    if action[0] > -1 and action[1] == 1:
                        enviro.doAction(enviro.you, action, enviro.gasGauges) # build a generator               
                    
                if event.key in enviro.genKeys:
                    genLocation = enviro.genKeys.index(event.key)
                    
                    if (genLocation == 4): # the base, add a harvester
                        harvCount = len(enviro.harvesters)
                        if (harvCount < 10):
                            print "You bought a harvester!"
                            newHarv = Harvester(len(enviro.harvesters))
                            enviro.harvesters.append(newHarv)
                            harvCount = len(enviro.harvesters)
                            print "Now have", harvCount, "harvesters"
                            #displayNewHarvester()
                        else:
                            print "Max 10 harvesters!"
                    else: # a producing location, add a generator
                        foundGen = False
                        for generator in enviro.generators:
                            if generator.location == genLocation:
                                foundGen = True
                        if (foundGen == False):
                            print "You bought a generator!"
                            newGen = Generator(genLocation,enviro.gasGauges)
                            enviro.generators.append(newGen)
                            
        """ now do all the stuff that happens each frame: """
        
        if not paused:
            for generator in enviro.generators:
                generator.produce(enviro.gasGauges)
            shieldPower = enviro.shields.powerUp(shieldPower, enviro.fuelPile)
            shieldSprite = enviro.shields.paintShield(shieldPower)

            frustration += 1
            if frustration > enviro.MOTHER_FLEET_INCREASE_WAITTIME:
                frustration = 0
                fightersActive += 1
                if fightersActive > enviro.mother.getFleetSize():
                   fightersActive = enviro.mother.getFleetSize()            

            # paint her progress, and get any emitted bombs
            theMother = enviro.mother.paint(bombList, fightersActive) 
            bombList = theMother[0]
            drama = theMother[1]
            herState = theMother[2]
            
            if not herState == "Waiting":
                if not motherBecameActive:
                    motherBecameActive = True
                    if pygame.mixer:
                        Noise.playMusic('Grinder-1.ogg')
##                        music = os.path.join('Sound', 'Grinder-1.ogg')
##                        pygame.mixer.music.load(music)
##                        pygame.mixer.music.play(-1)
                
            if drama == 1:
                shieldPower = shieldPower - enviro.BOMB_POWER
                if shieldPower < 0:
                    shieldPower = 0
                enviro.shields.hitShield(shieldPower)
                enviro.shields.paintShield(shieldPower)
                enviro.soundEffect[Noise.SHIELD_HIT].play()
                
            if len(bombList) > 0:
                for bomb in bombList:
                    if bomb.move() == 0 and bomb.rect.top == 430:
                        if theKillerBomb == None:
                            theKillerBomb = bomb
                            channel = pygame.mixer.find_channel(True)
                            if channel:
                                #print "got channel"
                                channel.play(enviro.soundEffect[Noise.MOTHER_HIT])
                            else:
                                print "no channel for mother kill sound, will try to use main"
                                enviro.soundEffect[Noise.MOTHER_HIT].play()                            
                            
                    if shieldPower > 0:
                        bomb.test(shieldSprite, "caught")                            
                            
                if not theKillerBomb == None:
                    if not theKillerBomb.nuked:
                        theKillerBomb.paint()
                        theKillerBomb.nuke()
                    else:
                        alive = 0
                    


        if not paused:
            for harvester in enviro.harvesters:
                harvester.getNextState(enviro.shields, 
                   enviro.theBase, enviro.generators, enviro.laser)
                
            for pad in enviro.padArray:
                pad.clearNeeds()

##        if not paused:
            next = enviro.you.moveYou(enviro.pads)
            if next <> "moving":
                if next == "up":
                    enviro.you.aimUp(enviro.pads)
                if next == "down":
                    enviro.you.aimDown(enviro.pads)
                if next == "right":
                    enviro.you.aimRight(enviro.pads)
                if next == "left":
                    enviro.you.aimLeft(enviro.pads)
                if next == "act":
                    action = enviro.you.interact(enviro.generators, 
                               enviro.shields, enviro.theBase, enviro.laser)
                    if action[0] > -1 and action[1] == 1:
                        enviro.doAction(enviro.you, action, enviro.gasGauges)

            autoTarget = False
            if not shooting:
                target = enviro.laser.autoTarget(bombList)            
                if target[0] > 0:
                    newCursor = target
                    shooting = True
                    autoTarget = True
            if shooting:
                shooting = enviro.laser.shoot(bombList, newCursor, 
                                             releasedButton, autoTarget)
                if enviro.mother.state == "Hit":
                    if pygame.mixer:
                        Noise.playMusic('Concrete Water.ogg')
                        motherBecameActive = False
                            
        if enviro.credits > 49999:
            alive=0
                    
        myClock.tick(30)
        fps = myClock.get_fps()
        #print fps
        console.draw()
        if not paused:
            pygame.display.flip()
    
    pygame.mixer.music.fadeout(1000)    
    if enviro.credits > 49999:
        enviro.winner()
    else:
        enviro.loser()
        
        
        
if __name__ == '__main__':
    main(False, True)
    
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                sys.exit()            

            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_c:
                    main(True, False)
                if event.key == pygame.K_r:
                    main(False, False)
                if event.key == pygame.K_q:
                    sys.exit()
                    
            if event.type == pygame.KEYDOWN:
                if (pygame.key.get_mods() == 1024): # command key
                    if (event.key == 113):   # q
                        sys.exit()                    
